import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Checkbox ,Modal, Upload ,Popconfirm} from 'antd';
import NewService from "./addService.jsx";
import moment from 'moment';
import '../userMangagement.less';
import {lvl,intentProgress,transactionProgress,contractProgress,projectProgress} from '../../../dataDic.js';
import {getIntentProgress,getTransactionProgress,getContractProgress,getProjectProgress,splitUrl} from '../../../tools.js';

const MyService=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/roles',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                customerName:this.state.customerName,
                startDate: this.state.releaseDate[0],
				endDate: this.state.releaseDate[1],
				transactionProgress:this.state.transactionProgress,
				contractProgress:this.state.contractProgress,
				projectProgress:this.state.projectProgress,
				settlementState:this.state.settlementState,
				orderStatus:this.state.orderStatus,
				approved:this.state.approved,
				orderChannel:this.state.orderChannel,
				intentOrder:this.state.intentOrder?'1':'0',
				formalOrder:this.state.formalOrder?'1':'0'
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         roleName: thisdata.roleName,
	                         creater:thisdata.creater,
	                         createTime:thisdata.createTimez,
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[]
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            releaseDate: [],
            signBillState:false,
            signBillVisible:false,
            selectedRows: [],
            searchMore: true,
            loading: false,
            intentOrder:false,
            formalOrder:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'roleName',
                    key: 'roleName'
                }, {
                    title: '订单类型',
                    dataIndex: 'creater',
                    key: 'creater'
                }, {
                    title: '下单时间',
                    dataIndex: 'creater7',
                    key: 'creater7'
                },{
                    title: '订单客户',
                    dataIndex: 'roleName1',
                    key: 'roleName1'
                }, {
                    title: '实际下单金额',
                    dataIndex: 'creater1',
                    key: 'creater1'
                }, {
                    title: '意向进度',
                    dataIndex: 'createTime1',
                    key: 'createTime1',
                    render:(text)=>{return getIntentProgress(text) }
                },{
                    title: '交易进度',
                    dataIndex: 'roleName2',
                    key: 'roleName2',
                    render:(text)=>{return getTransactionProgress(text) }
                }, {
                    title: '合同进度',
                    dataIndex: 'creater2',
                    key: 'creater2',
                    render:(text)=>{return getContractProgress(text) }
                }, {
                    title: '项目进度',
                    dataIndex: 'creatu',
                    key: 'creatu',
                    render:(text)=>{return getProjectProgress(text) }
                },{
                    title: '结算状态',
                    dataIndex: 'roleName3',
                    key: 'roleName3'
                }, {
                    title: '订单状态',
                    dataIndex: 'creater3',
                    key: 'creater3'
                }, {
                    title: '是否特批',
                    dataIndex: 'creat',
                    key: 'creat'
                },{
                    title: '订单渠道',
                    dataIndex: 'cre',
                    key: 'cre'
                },{
                    title: '操作',
                    dataIndex: 'ccc',
                    key: 'ccc',
                    render: (text, record, index) => {
						return <div>
							<Popconfirm title={'请确认您是否受理来自【'+record.roleName+'】发起的服务意向订单？'} onConfirm={(e)=>{this.admissibleOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="primary">受理意向</Button>                 
							</Popconfirm>
							<Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation(),this.signBill(record)}} type="primary">签单</Button>                 
							<Popconfirm title={'请确认您是否取消客户【'+record.roleName+'】的服务订单，订单取消将导致业务终止！'} onConfirm={(e)=>{this.cancelOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">取消订单</Button>                 
							</Popconfirm>
							<Popconfirm title={'请确认您是否作废客户【'+record.roleName+'】的服务订单，订单作废将导致订单失效！'} onConfirm={(e)=>{this.scrapOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">作废</Button>                 
							</Popconfirm>
							<Popconfirm title={'请确认您是否锁定客户【'+record.roleName+'】的服务订单，订单锁定将导致订单暂停！'} onConfirm={(e)=>{this.lockOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">锁定<Icon type="lock" /></Button>                 
							</Popconfirm>
							<Popconfirm title={'请确认您是否解锁客户【'+record.roleName+'】的服务订单，订单解锁将导致订单正常！'} onConfirm={(e)=>{this.unlockOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="primary">解锁<Icon type="unlock" /></Button>                 
							</Popconfirm>
                        </div>
					}
                }
            ],
            dataSource: [],
        };
    },
    //受理订单
    admissibleOrder(e){
    	this.operation(e,'admissibleOrder')
    },
    //取消订单
    cancelOrder(e){
    	this.operation(e,'cancelOrder')
    },
    //作废订单
    scrapOrder(e){
    	this.operation(e,'scrapOrder')
    },
    //锁定订单
    lockOrder(e){
    	this.operation(e,'lockOrder')
    },
    //解锁订单
    unlockOrder(e){
    	this.operation(e,'unlockOrder')
    },
    //签单
    signBill(ids){
    	this.setState({
    		uid:ids,
    		signBillVisible:true
    	})
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
        	signBillVisible:false,
        	signBillState:true,
            showDesc: true
        });
    },
    //列表各种骚操作
    operation(record,index) {
    	let api;
        switch(index){
        	case 'admissibleOrder':
        		api='/api/shoulidingdan';
        		break;
        	case 'cancelOrder':
        		api='/api/quxiaodingdan';
        		break;
        	case 'scrapOrder':
        		api='/api/zuofeidingdan';
        		break;
        	case 'lockOrder':
        		api='/api/suodingdingdan';
        		break;
        	case 'unlockOrder':
        		api='/api/jiesuodingdan';
        		break;
        	default:
        	return false;
        }
        this.setState({
            selectedRowKeys: [],
            loading: true,
            showDesc:false
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + api,
            data: {
            	id:record.id
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    addClick() {
    	this.state.userDetaile=false;
        this.setState({
        	signBillVisible:false,
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    searchSwitch() {
		this.setState({
			signBillVisible:false,
			searchMore: !this.state.searchMore
		});
	},
    search() {
    	this.setState({
    		signBillVisible:false
    	})
        this.loadData();
    },
    reset() {
    	this.setState({
    		signBillVisible:false
    	})
    	this.state.customerName='';
    	this.state.releaseDate[0] = undefined;
		this.state.releaseDate[1] = undefined;
		this.state.transactionProgress = undefined;
		this.state.contractProgress = undefined;
		this.state.projectProgress = undefined;
		this.state.settlementState = undefined;
		this.state.orderStatus = undefined;
		this.state.approved = undefined;
		this.state.orderChannel = undefined;
		this.state.formalOrder=false;
		this.state.intentOrder=false;
        this.loadData();       
    },
    render() {
    	const FormItem = Form.Item;
    	const formItemLayout = {
			labelCol: { span: 8 },
			wrapperCol: { span: 14 },
		};
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>我的订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.customerName}
	                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />
	                    <RangePicker
		                        value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
		                        this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
		                        onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />     
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索<Icon type="search" /></Button>
	                    <Button onClick={this.reset}>重置 <Icon type="reload" /></Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                    <Button type="primary" className="addButton" onClick={this.addClick} >开单<Icon type="plus" /></Button>
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>   
	                  		<Checkbox checked={this.state.intentOrder} onChange={(e)=>{this.setState({intentOrder:!this.state.intentOrder})}}>意向订单</Checkbox>
	                  		<Checkbox checked={this.state.formalOrder} onChange={(e)=>{this.setState({formalOrder:!this.state.formalOrder})}}>正式订单</Checkbox>
	                  		<Select placeholder="订单状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.orderStatus}
	                            onChange={(e) => { this.setState({ orderStatus: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="结算状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.settlementState}
	                            onChange={(e) => { this.setState({ settlementState: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="项目进度"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.projectProgress}
	                            onChange={(e) => { this.setState({ projectProgress: e }) }}>
	                            {
                                    projectProgress.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="是否特批"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.approved}
	                            onChange={(e) => { this.setState({ approved: e }) }}>
	                            <Select.Option value="0" >未特批</Select.Option>
	                            <Select.Option value="1" >已特批</Select.Option>
	                        </Select>
	                        <Select placeholder="订单渠道"
	                            style={{ width: 150 }}
	                            value={this.state.orderChannel}
	                            onChange={(e) => { this.setState({ orderChannel: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <NewService
	                	uid={this.state.uid}
	                	signBillVisible={this.state.signBillVisible}
	                    signBillState={this.state.signBillState}
	                	operation={this.operation}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
            </div>
        );
    }
}));

export default MyService;

